unit Client15;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, ExtCtrls, Ftpcli, WSocket;

type
  TForm15 = class(TForm)
    Panel1: TPanel;
    Gauge1: TGauge;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Label7: TLabel;
    Timer1: TTimer;
    WSocket1: TWSocket;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure WSocket1DataAvailable(Sender: TObject; Error: Word);
    procedure WSocket1SessionConnected(Sender: TObject; Error: Word);
    procedure WSocket1SessionClosed(Sender: TObject; Error: Word);
  private
    { Private declarations }
  public
    { Public declarations }
    ByteCount, FileSize, LastCount: integer;
    LastTime: DWord;
    ArrayIndex: Array[1..50] of Integer;
    TransferFile: TFileStream;
    ReceivedFileInfo, FileName: string;
    TransferInProgress: boolean;
  end;

var
  Form15: TForm15;

implementation

uses Shared1;

{$R *.DFM}

procedure TForm15.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TForm15.FormClose(Sender: TObject; var Action: TCloseAction);
begin
WSocket1.Abort;
TransferFile.Free;
Release;
end;

procedure TForm15.FormCreate(Sender: TObject);
begin
Timer1.Interval := 1;
ReceivedFileInfo := '';
TransferInProgress := false;
end;

procedure TForm15.Timer1Timer(Sender: TObject);
var a, i, BPS: integer;
begin
Gauge1.Progress := ByteCount;

if (GetTickCount - LastTime) <> 0 then
begin

Label3.Caption := BytesToText(ByteCount) + ' of ' +  BytesToText(Gauge1.MaxValue);
BPS := ((ByteCount - LastCount) div Integer(GetTickCount - LastTime)) * 1000;

for I := 2 to 50 do
ArrayIndex[i] := ArrayIndex[I - 1];

ArrayIndex[1] := BPS;

A := 0;

for i := 1 to 50 do
Inc(A, ArrayIndex[i]);

A := A div 50;

ArrayIndex[1] := A;

Label4.Caption := Format('%.2f', [ArrayIndex[1] / 1024]) + ' KB/s';
end;

LastTime := GetTickCount;
LastCount := ByteCount;

end;

procedure TForm15.WSocket1DataAvailable(Sender: TObject; Error: Word);
var S: string;
    i: integer;
begin

S := WSocket1.ReceiveStr;

if TransferInProgress then
begin
TransferFile.Write(S[1], Length(S));
ByteCount := TransferFile.Size;
end else
for i := 1 to Length(S) do
if S[i] = #0 then
begin

if ReceivedFileInfo[1] = 'D' then
begin
Label7.Caption := 'Downloading...';

FileSize := StrToInt(Copy(ReceivedFileInfo, 2, i - 2));

S := Copy(S, I + 1, Length(S));
TransferFile.Write(S[1], Length(S));
ByteCount := TransferFile.Size;

if ByteCount = FileSize then
begin
WSocket1.Abort;
Close;
end;

end else
begin
WSocket1.Abort;
Label7.Caption := 'Failed: ' + Copy(ReceivedFileInfo, 2, i - 2);
end;

Break;
end else
ReceivedFileInfo := ReceivedFileInfo + S[i];

end;

procedure TForm15.WSocket1SessionConnected(Sender: TObject; Error: Word);
begin

if error = 0 then
Label7.Caption := 'Getting File Information...' else
Label7.Caption := 'Failed: Couldn''t connect.';

end;

procedure TForm15.WSocket1SessionClosed(Sender: TObject; Error: Word);
begin

if Label7.Caption <> 'Failed: Couldn''t connect.' then
Label7.Caption := 'Failed: Lost connection.';

end;

end.
